small fixes
[distro-setup] / .bashrc
diff --git a/.bashrc b/.bashrc
index ed0084b2db9e242d7282b0e4b61e502521e89618..dfc10aeaa90ab021500cacfc3b88cc81f82763a4 100644 (file)
--- a/.bashrc
+++ b/.bashrc
@@ -1,15 +1,29 @@
+# Copyright (C) 2016 Ian Kelling
+
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+
+#     http://www.apache.org/licenses/LICENSE-2.0
+
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
 # to debug
 #set -x
-# redirect output to log file
-#exec 1>/a/tmp/bashlog
-#exec 2>/a/tmp/bashlog
+# redirect output to log file. this doesn't work. todo figure out why
+#exec 1>>/a/tmp/bashlog
+#exec 2>>/a/tmp/bashlog
 
 
 # By default this file is sourced for ALL ssh commands. This is wonky.
-# Normally, this file is not sourced when a script is run, but we can override
-# that by having #!/bin/bash -l.
-# I want something similar for ssh commands. when a local script runs an ssh command,
-# this file should not be sourced by default, but we should be able to override that.
+# Normally, this file is not sourced when a script is run, but we can
+# override that by having #!/bin/bash -l.  I want something similar for ssh
+# commands. when a local script runs an ssh command, this file should not be
+# sourced by default, but we should be able to override that.
 #
 # so here we test for conditions of a script under ssh and return if so. To test
 # for an overriding condition, we have a few options. one is to use an
@@ -33,17 +47,26 @@ if [[ $SSH_CONNECTION ]] \
        && [[ $- != *i* ]] \
        && [[ ! $BASH_LOGIN_SHELL == true ]]; then
     return
+else
+    source /etc/profile
 fi
 
 
 
+# note, to catch errors in functions but not outside, do:
+# set -E -o pipefail
+# trap return ERR
+# trap 'trap ERR' RETURN
+
 
 
 ############
 # settings #
 ############
 
-CDPATH=.:/a
+CDPATH=.
+
+set -o pipefail
 
 # remove all aliases. aliases provided by the system tend to get in the way,
 # for example, error happens if I try to define a function the same name as an alias
@@ -64,7 +87,8 @@ export GLOBIGNORE=*/.:*/..
 # still broken in wheezy
 # still buggered in latest stable from the web, version 2.1
 # perhaps its fixed in newer git version, which fails to make for me
-# this note is from 6-2014
+# this note is from 6-2014.
+# Also, enabling this before sourcing .bashrc makes PATH be empty.
 #shopt -s nullglob
 
 # make tab on an empty line do nothing
@@ -100,6 +124,28 @@ if [[ $INSIDE_EMACS ]]; then
     # scp completion does not work, but this doesn't fix it. todo, figure this out
     complete -r scp &> /dev/null
     # todo, remote file completion fails, figure out how to turn it off
+    export NODE_DISABLE_COLORS=1
+    # This get's rid of ugly terminal escape chars in node repl
+    # sometime, I'd like to have completion working in emacs shell for node
+    # the offending chars can be found in lib/readline.js,
+    # things that do like:
+    # stream.write('\x1b[' + (x + 1) + 'G');
+    # We can remove them and keep readline, for example by doing this
+    # to start a repl:
+    #!/usr/bin/env nodejs
+    # var readline = require('readline');
+    # readline.cursorTo = function(a,b,c) {};
+    # readline.clearScreenDown = function(a) {};
+    # const repl = require('repl');
+    # var replServer = repl.start('');
+    #
+    # no prompt, or else readline complete seems to be confused, based
+    # on our column being different? node probably needs to send
+    # different kind of escape sequence that is not ugly. Anyways,
+    # completion doesn't work yet even with the ugly prompt, so whatever
+    #
+    export NODE_NO_READLINE=1
+
 fi
 
 
@@ -149,7 +195,7 @@ HISTCONTROL=ignoredups
 # works in addition to HISTCONTROL to do more flexible things
 # it could also do the same things as HISTCONTROL and thus replace it,
 # but meh
-HISTIGNORE="k *"
+HISTIGNORE='k *; *'
 
 export BC_LINE_LENGTH=0
 
@@ -160,76 +206,55 @@ export BC_LINE_LENGTH=0
 C_DEFAULT_DIR=/a
 
 
-
-
 ###################
 ## include files ###
 ###################
 
-for _x in $HOME/bin/bash-programs-by-ian/repos/*/*-function ~/opt/distro-functions/src/*; do
+for _x in /a/bin/distro-functions/src/* /a/bin/!(githtml)/*-function?(s); do
     source "$_x"
 done
 unset _x
-source $HOME/bin/semi-private # so I can share my bashrc
-source $HOME/path_add-function
-path_add --ifexists /a/opt/adt-bundle*/tools /a/opt/adt-bundle*/platform-tools
-path_add $HOME/bin/bash-programs-by-ian/utils
-source $HOME/mw_vars
+# so I can share my bashrc
+for x in /a/bin/bash_unpublished/source-!(.#*); do source $x; done
+source $(dirname $(readlink -f $BASH_SOURCE))/path_add-function
+source /a/bin/log-quiet/logq-function
+path_add /a/exe
+path_add --ifexists --end /a/opt/adt-bundle*/tools /a/opt/adt-bundle*/platform-tools
+# todo, these need to be renamed to be less generic.
+# sync overrode something else useful
+#path_add $HOME/bin/bash-programs-by-ian/utils
+
 
 ###############
 ### aliases ###
 ###############
 
-# disabled for now, but these are generally good
-# if [[ $- == *i* ]]; then
-#     alias cp='cp -i'
-#     alias mv='mv -i'
-# fi
+# very few aliases, functions are always preferred.
 
-# remove any default aliases for these
-alias ls > /dev/null 2>&1 && unalias ls
-alias ll > /dev/null 2>&1 && unalias ll
-alias grep > /dev/null 2>&1 && unalias grep
-
-
-mkdir() {
-    command mkdir -p "$@"
-}
+# ancient stuff.
+if [[ $OS == Windows_NT ]]; then
+    alias ffs='cygstart "/c/Program Files (x86)/Mozilla Firefox/firefox.exe" -P scratch'
+    export DISPLAY=nt
+    alias j='command cygpath'
+    alias t='command cygstart'
+    alias cygstart='echo be quick, use the alias "t" instead :\)'
+    alias cygpath='echo be quick, use the alias "j" instead :\)'
+fi
 
 
-alias d='builtin bg'
-complete -A stopped -P '"%' -S '"' d
 
-alias hi='history'
+# keep this in mind? good for safety.
+# alias cp='cp -i'
+# alias mv='mv -i'
 
 
-# note: gksudo is recommended for X apps because it does not set the
-# home directory to the same.
+# remove any default aliases for these
+unalias ls ll grep &>/dev/null ||:
 
-if [[ $- == *i* ]]; then
-    # extra space at the end allows aliases to work
-    alias s='SUDOD="$PWD" sudo -i '
-else
-    s() {
-        if [[ $EUID != 0 || $1 == -* ]]; then
-            SUDOD="$PWD" sudo -i "$@"
-        else
-            "$@"
-        fi
-    }
-fi
 
 
 
-if [[ $OS == Windows_NT ]]; then
-    alias ffs='cygstart "/c/Program Files (x86)/Mozilla Firefox/firefox.exe" -P scratch'
-    export DISPLAY=nt
-    alias j='command cygpath'
-    alias t='command cygstart'
-    alias cygstart='echo be quick, use the alias "t" instead :\)'
-    alias cygpath='echo be quick, use the alias "j" instead :\)'
 
-fi
 
 
 
@@ -239,73 +264,82 @@ fi
 ###  functions   ####
 #####################
 
-# netselect-apt finds a fast mirror.
-# but we need to replace the mirrors ourselves,
-# because it doesn't do that. best it can do is
-# output a basic sources file
-# here we get the server it found, get the main server we use
-# then substitute all instances of one for the other in the sources file
-# and backup original to /etc/apt/sources.list-original.
-# this is idempotent
-debian_pick_mirror () {
-    local x=$(mktemp -d)/f # safe way to get file name without creating one
-    sudo netselect-apt -o "$x" || return 1
-    x=$(_debian_pick_mirror_grep stable "$x")
-    sudo cp -f /etc/apt/sources.list /etc/apt/sources.list-original
-    sudo sed -i "s/$(_debian_pick_mirror_grep wheezy)/$x/" /etc/apt/sources.list
-    aptitude update
-}
 
-_debian_pick_mirror_grep () {
-    local x="$(grep -oP "^deb [^ ]+ $1 " ${2-/etc/apt/sources.list})"
-    x="${x#deb }"
-    x="${x% $1 }"
-    # replace / with \/ so we can use it with sed
-    echo "${x//\//\\/}"
-}
 
-# portable daemon, for debian & fedora
-pdaemon () {
-    if isdeb; then
-        sudo /etc/init.d/$1 $2
-    else
-        sudo systemctl $2 $1.service
-    fi
-}
 
-a() {
-    beet "${@}"
+# file cut copy and paste, like the text buffers :)
+# I havn't tested these.
+_fbufferinit() { # internal use by
+    ! [[ $my_f_tempdir ]] && my_f_tempdir=$(mktemp -d)
+    rm -rf "$my_f_tempdir"/*
 }
-
-
-t() {
-    trash-put "$@"
+fcp() { # file cp
+    _fbufferinit
+    cp "$@" "$my_f_tempdir"/
+}
+fct() { # file cut
+    _fbufferinit
+    mv "$@" "$my_f_tempdir"/
+}
+fpst() { # file paste
+    [[ $2 ]] && { echo too many arguments; return 1; }
+    target=${1:-.}
+    cp "$my_f_tempdir"/* "$target"
 }
 
 
-if type ack-grep >/dev/null 2>&1; then
-    alias ack=ack-grep
-fi
+# todo, update this
+complete -F _longopt la lower low rlt rld rl lld ts ll dircp ex fcp fct fpst gr
 
 
-gr() {
-    grep -i --binary-files=without-match --color=auto "$@"
+_cdiff-prep() {
+    # join options which are continued to multiples lines onto one line
+    local first=true
+    grep -vE '^([ \t]*#|^[ \t]*$)' "$1" | while IFS= read -r line; do
+        # remove leading spaces/tabs. assumes extglob
+        if [[ $line == "[      ]*" ]]; then
+            line="${line##+( )}"
+        fi
+        if $first; then
+            pastline="$line"
+            first=false
+        elif [[ $line == *=* ]]; then
+            echo "$pastline" >> "$2"
+            pastline="$line"
+        else
+            pastline="$pastline $line"
+        fi
+    done
+    echo "$pastline" >> "$2"
 }
 
-grr() {
-    grep -ri --binary-files=without-match --color=auto "$@"
+_khfix_common() {
+    local h=${1##*@}
+    ssh-keygen -R $h -f $(readlink -f ~/.ssh/known_hosts)
+    local x=$(timeout 0.1 ssh -v $1 |& sed -rn "s/debug1: Connecting to $h \[([^\]*)].*/\1/p");
+    ssh-keygen -R $x -f $(readlink -f ~/.ssh/known_hosts)
+}
+khfix() { # known hosts fix
+    _khfix_common "$@"
+    ssh $1 :
+}
+khcopy() {
+    _khfix_common "$@"
+    ssh-copy-id $1
 }
 
-pub() {
-    rsync -rhc /a/h/_site/ li:/var/www/iankelling.org/public_html
+a() {
+    beet "${@}"
 }
 
+ack() { ack-grep "$@"; }
+
 bashrcpush () {
     local startdir="$PWD"
     cd ~
     for x in "$@"; do
-        ssh $x mkdir -p bin opt/distro-functions
-        tar cz bin/bash-programs-by-ian bin/semi-private opt/distro-functions/src | ssh $x tar xz
+        ssh $x mkdir -p bin/distro-functions/src
+        tar cz bin/semi-private bin/distro-functions/src | ssh $x tar xz
     done
     cd $(mktemp -d)
     command cp /a/c/repos/bash/!(.git) ~/.gitconfig .
@@ -315,22 +349,33 @@ bashrcpush () {
     cd "$startdir"
 }
 
-# history search
-k() { grep -P "$@" ${HISTFILE:-~/.bash_history}  | tail -n 40; }
+caa() { git commit --amend --no-edit -a; }
 
 calc() { echo "scale=3; $*" | bc -l; }
+# no having to type quotes, but also no command history:
+clc() {
+    local x
+    read -r x
+    echo "scale=3; $x" | bc -l
+}
 
-# diff config files,
-# setup for format of postfix
-# option = stuff[,]
-#    [more stuff]
-cdiff() {
+cam() {
+    git commit -am "$*"
+}
 
+ccat () { # config cat. see a config without extra lines.
+    grep '^\s*[^[:space:]#]' "$@"
+}
+
+cdiff() {
+    # diff config files,
+    # setup for format of postfix, eg:
+    # option = stuff[,]
+    #    [more stuff]
     local pastline
     local unified="$(mktemp)"
     local f1="$(mktemp)"
     local f2="$(mktemp)"
-
     _cdiff-prep "$1" "$f1"
     _cdiff-prep "$2" "$f2"
     cat "$f1" "$f2" |  grep -Po '^[^=]+=' | sort | uniq > "$unified"
@@ -340,107 +385,242 @@ cdiff() {
     done < "$unified"
 }
 
-
-# join options which are continued to multiples lines onto one line
-_cdiff-prep() {
-    local first=true
-    grep -vE '^([ \t]*#|^[ \t]*$)' "$1" | while IFS= read -r line; do
-                                              # remove leading spaces/tabs. assumes extglob
-                                              if [[ $line == "[        ]*" ]]; then
-                                                  line="${line##+( )}"
-                                              fi
-                                              if $first; then
-                                                  pastline="$line"
-                                                  first=false
-                                              elif [[ $line == *=* ]]; then
-                                                  echo "$pastline" >> "$2"
-                                                  pastline="$line"
-                                              else
-                                                  pastline="$pastline $line"
-                                              fi
-                                          done
-    echo "$pastline" >> "$2"
+cgpl()
+{
+    if (($#)); then
+        cp /a/bin/data/COPYING "$@"
+    else
+        cp /a/bin/data/COPYING .
+    fi
+}
+capache()
+{
+    if (($#)); then
+        cp /a/bin/data/LICENSE "$@"
+    else
+        cp /a/bin/data/LICENSE .
+    fi
 }
-
-# makes it so chown -R symlink affects the symlink and its target.
 chown() {
+    # makes it so chown -R symlink affects the symlink and its target.
     if [[ $1 == -R ]]; then
-       shift
-       command chown -h "$@"
-       command chown "$@"
-       command chown -RH "$@"
+        shift
+        command chown -h "$@"
+        command chown -R "$@"
     else
-       command chown "$@"
+        command chown "$@"
     fi
 }
 
+cim() {
+    git commit -m "$*"
+}
 
+d() { builtin bg; }
+complete -A stopped -P '"%' -S '"' d
 
-cgpl ()
-{
-    if [[ $# == 0 ]]; then
-        cp /a/bin/data/COPYING .
-    else
-        cp /a/bin/data/COPYING "$@"
-    fi
+dat() { # do all tee, for more complex scripts
+    tee >(ssh frodo bash -l) >(bash -l) >(ssh x2 bash -l) >(ssh tp bash -l)
+}
+da() { # do all
+    local host
+    "$@"
+    for host in x2 tp treetowl; do
+        ssh $host "$@"
+    done
 }
-
 
 dc() {
     diff --strip-trailing-cr -w "$@"   # diff content
 }
 
+debian_pick_mirror () {
+    # netselect-apt finds a fast mirror.
+    # but we need to replace the mirrors ourselves,
+    # because it doesn't do that. best it can do is
+    # output a basic sources file
+    # here we get the server it found, get the main server we use
+    # then substitute all instances of one for the other in the sources file
+    # and backup original to /etc/apt/sources.list-original.
+    # this is idempotent. the only way to identify debian sources is to
+    # note the original server, so we put it in a comment so we can
+    # identify it later.
+    local file=$(mktemp -d)/f # safe way to get file name without creating one
+    sudo netselect-apt -o "$file" || return 1
+    url=$(grep ^\\w $file | head -n1 | awk '{print $2}')
+    sudo cp -f /etc/apt/sources.list /etc/apt/sources.list-original
+    sudo sed -ri "/http.us.debian.org/ s@( *[^ #]+ +)[^ ]+([^#]+).*@\1$url\2# http.us.debian.org@" /etc/apt/sources.list
+    sudo apt-get update
+}
+
+despace() {
+    local x y
+    for x in "$@"; do
+        y="${x// /_}"
+        safe_rename "$x" "$y"
+    done
+}
 
 dt() {
     date "+%A, %B %d, %r" "$@"
 }
 
+dus() {
+    du -sh ${@:-*} | sort -h
+}
+
+
 
 e() { echo "$@"; }
 
 
+ediff() {
+    [[ ${#@} == 2 ]] || { echo "error: ediff requires 2 arguments"; return 1; }
+    emacs --eval "(ediff-files \"$1\" \"$2\")"
+}
+
+
 envload() { # load environment from a previous: export > file
     local file=${1:-$HOME/.${USER}_env}
     eval "$(export | sed 's/^declare -x/export -n/')"
     while IFS= read -r line; do
-       # declare -x makes variables local to a function
-       eval ${line/#declare -x/export}
+        # declare -x makes variables local to a function
+        eval ${line/#declare -x/export}
     done < "$file"
 }
 
 
+fa() {
+    # find array. make an array of file names found by find into $x
+    # argument: find arguments
+    # return: find results in an array $x
+    while read -rd ''; do
+        x+=("$REPLY");
+    done < <(find "$@" -print0);
+}
 
-# havn't tested these:
-#file cut copy and paste, like the text buffers :)
-_fbufferinit() { # internal use by
-    ! [[ $my_f_tempdir ]] && my_f_tempdir=$(mktemp -d)
-    rm -rf "$my_f_tempdir"/*
+
+ff() {
+    if type -P firefox &>/dev/null; then
+        firefox "$@"
+    else
+        iceweasel "$@"
+    fi
 }
-fcp() { # file cp
-    _fbufferinit
-    cp "$@" "$my_f_tempdir"/
+
+
+
+fn() {
+    firefox -P alt "$@" >/dev/null 2>&1
 }
-fct() { # file cut
-    _fbufferinit
-    mv "$@" "$my_f_tempdir"/
+
+
+fsdiff () {
+    local missing=false
+    local dname="${PWD##*/}"
+    local m="/a/tmp/$dname-missing"
+    local d="/a/tmp/$dname-diff"
+    [[ -e $d ]] && rm "$d"
+    [[ -e $m ]] && rm "$m"
+    local msize=0
+    local fsfile
+    while read -r line; do
+        fsfile="$1${line#.}"
+        if [[ -e "$fsfile" ]]; then
+            md5diff "$line" "$fsfile" && tee -a "/a/tmp/$dname-diff" <<< "$fsfile $line"
+        else
+            missing=true
+            echo "$line" >> "$m"
+            msize=$((msize + 1))
+        fi
+    done < <(find -type f )
+    if $missing; then
+        echo "$m"
+        (( msize <= 100 )) && cat $m
+    fi
 }
-fpst() { # file paste
-    [[ $2 ]] && { echo too many arguments; return 1; }
-    target=${1:-.}
-    cp "$my_f_tempdir"/* "$target"
+fsdiff-test() {
+    # expected output, with different tmp dirs
+    # /tmp/tmp.HDPbwMqdC9/c/d ./c/d
+    # /a/tmp/tmp.qLDkYxBYPM-missing
+    # ./b
+    cd $(mktemp -d)
+    echo ok > a
+    echo nok > b
+    mkdir c
+    echo ok > c/d
+    local x=$(mktemp -d)
+    mkdir $x/c
+    echo different > $x/c/d
+    echo ok > $x/a
+    fsdiff $x
+}
+rename-test() {
+    # test whether missing files were renamed, generally for use with fsdiff
+    # $1 = fsdiff output file, $2 = directory to compare to. pwd = fsdiff dir
+    # echos non-renamed files
+    local x y found
+    unset sums
+    for x in "$2"/*; do
+        { sums+=( "$(md5sum < "$x")" ) ; } 2>/dev/null
+    done
+    while read -r line; do
+        { missing_sum=$(md5sum < "$line") ; } 2>/dev/null
+        renamed=false
+        for x in "${sums[@]}"; do
+            if [[ $missing_sum == "$x" ]]; then
+                renamed=true
+                break
+            fi
+        done
+        $renamed || echo "$line"
+    done < "$1"
+    return 0
 }
 
+feh() {
+    command feh -FzZ "$@"
+}
 
-# find array. make an array of file names found by find into $x
-# argument: find arguments
-# return: find results in an array $x
-fa() {
-    while read -rd ''; do
-       x+=("$REPLY");
-    done < <(find "$@" -print0);
+funce() {
+    # like -e for functions. returns on error.
+    # at the end of the function, disable with:
+    # trap ERR
+    trap 'echo "${BASH_COMMAND:+BASH_COMMAND=\"$BASH_COMMAND\" }
+${FUNCNAME:+FUNCNAME=\"$FUNCNAME\" }${LINENO:+LINENO=\"$LINENO\"  }\$?=$?"
+trap ERR
+return' ERR
 }
 
 
+fw() {
+    firefox -P default "$@" >/dev/null 2>&1
+}
+
+getdir () {
+    local help="Usage: getdir [--help] PATH
+Output the directory of PATH, or just PATH if it is a directory."
+    if [[ $1 == --help ]]; then
+        echo "$help"
+        return 0
+    fi
+    if [[ $# -ne 1 ]]; then
+        echo "getdir error: expected 1 argument, got $#"
+        return 1
+    fi
+    if [[ -d $1 ]]; then
+        echo "$1"
+    else
+        local dir="$(dirname "$1")"
+        if [[ -d $dir ]]; then
+            echo "$dir"
+        else
+            echo "getdir error: directory does not exist"
+            return 1
+        fi
+    fi
+}
+
 git_empty_branch() { # start an empty git branch. carefull, it deletes untracked files.
     [[ $# == 1 ]] || { echo 'need a branch name!'; return 1;}
     local gitroot
@@ -451,228 +631,180 @@ git_empty_branch() { # start an empty git branch. carefull, it deletes untracked
     git clean -fdx
 }
 
+gitroot() {
+    local help="Usage: gitroot [--help]
+Print the full path to the root of the current git repo
 
-ff() {
-    if type -P firefox &>/dev/null; then
-        firefox "$@"
-    else
-        iceweasel "$@"
+Handles being within a .git directory, unlike git rev-parse --show-toplevel,
+and works in older versions of git which did not have that."
+    if [[ $1 == --help ]]; then
+        echo "$help"
+        return
     fi
+    local p=$(git rev-parse --git-dir) || { echo "error: not in a git repo" ; return 1; }
+    [[ $p != /* ]] && p=$PWD
+    echo "${p%%/.git}"
 }
 
-fw() {
-    firefox -P default "$@" >/dev/null 2>&1
+gr() {
+    grep -iIP --color=auto "$@"
 }
 
-fn() {
-    firefox -P alt "$@" >/dev/null 2>&1
+grr() {
+    if [[ ${#@} == 1 ]]; then
+        grep -riIP --color=auto "$@" .
+    else
+        grep -riIP --color=auto "$@"
+    fi
 }
 
+hl() { # history limit. Write extra history to archive file.
+    # todo: this is not working or not used currently
+    local max_lines linecount tempfile prune_lines x
+    local harchive="${HISTFILE}_archive"
+    for x in "$HISTFILE" "$harchive"; do
+        [[ -e $x ]] || { touch "$x" && echo "notice from hl(): creating $x"; }
+        if  [[ ! $x || ! -e $x || ! -w $x || $(stat -c "%u" "$x") != $EUID  ]];  then
+            echo "error in hl: history file \$x:$x no good"
+            return 1
+        fi
+    done
+    history -a # save history
+    max_lines=$HISTFILELINES
+    [[ $max_lines =~ ^[0-9]+$ ]] || { echo "error in hl: failed to get max line count"; return 1; }
+    linecount=$(wc -l < $HISTFILE) # pipe so it doesn't output a filename
+    [[ $linecount =~ ^[0-9]+$ ]] || { echo "error in hl: wc failed"; return 1; }
+    if (($linecount > $max_lines)); then
+        prune_lines=$(($linecount - $max_lines))
+        head -n $prune_lines "$HISTFILE" >> "$harchive" \
+            && sed --follow-symlinks -ie "1,${prune_lines}d"  $HISTFILE
+    fi
+}
 
+hr() { # horizontal row. used to break up output
+    printf "$(tput setaf 5)â–ˆ$(tput sgr0)%.0s" $(seq $COLUMNS)
+    echo
+}
 
 
-
-# horizontal row. used to break up output
-hr() { printf "$(tput setaf 5)â–ˆ$(tput sgr0)%.0s" $(seq $COLUMNS); }
-
-
-i() {
-    git "$@"
-}
+i() { git "$@"; }
 # modified from ~/local/bin/git-completion.bash
 # other completion commands are mostly taken from bash_completion package
 complete -o bashdefault -o default -o nospace -F _git i 2>/dev/null \
     || complete -o default -o nospace -F _git i
 
-# fast commit
+if ! type service &>/dev/null; then
+    service() {
+        echo actually running: systemctl $2 $1
+        systemctl $2 $1
+    }
+fi
+
 ic() {
+    # fast commit all
     git commit -am "$*"
 }
 
-# insensitive find
+
 ifn () {
-    find . -iname '*'"$*"'*'
+    # insensitive find
+    find -L . -iname "*$**" 2>/dev/null
 }
 
 
+if [[ $OS == Windows_NT ]]; then
+    # cygstart wrapper
+    cs() {
+        cygstart "$@" &
+    }
+    xp() {
+        explorer.exe .
+    }
+    # launch
+    o() {
+        local x=(*$1*)
+        (( ${#x[#]} > 1 )) && { echo "warning ${#x[#]} matches found"; sleep 1; }
+        cygstart *$1* &
+    }
+else
+    o() {
+        if type gvfs-open &> /dev/null ; then
+            gvfs-open "$@"
+        else
+            xdg-open "$@"
+        fi
+        # another alternative is run-mailcap
+    }
+fi
+
+
+
+istext() {
+    grep -Il "" "$@" &>/dev/null
+}
 
 
 l() {
     if [[ $PWD == /[iap] ]]; then
-       command ls -A --color=auto -I lost+found "$@"
+        command ls -A --color=auto -I lost+found "$@"
     else
-       command ls -A --color=auto "$@"
+        command ls -A --color=auto "$@"
     fi
 }
 
 
+lcn() { locate -i "*$**"; }
 
-lld() { ll -d "$@"; }
-
-
-low() {  # make filenames all lowercase
-    local x y
-    for x in "$@"; do
-       y=$(tr "[A-Z]" "[a-z]" <<<"$x")
-       [[ $y != $x ]] && mv "$x" "$y"
-    done
-}
-
-
-lower() { # make first letter of filenames lowercase.
-    local x
-    for x in "$@"; do
-       if [[ ${x::1} == [A-Z] ]]; then
-           y=$(tr "[A-Z]" "[a-z]" <<<"${x::1}")"${x:1}"
-            safe_rename "$x" "$y"
-       fi
-    done
-}
-
-safe_rename() {
-    if [[ $# != 2 ]]; then
-        echo safe_rename error: $# args, need 2 >2
-        return 1
-    elif [[ $1 != $2 ]]; then
-        if [[ -e $2 ]]; then
-            echo Cannot rename "$1" to "$2" as it already exists.
-        else
-            mv "$1" "$2"
-        fi
-    fi
-}
+lld() { ll -d "$@"; }
 
-despace() {
+low() {  # make filenames all lowercase
     local x y
     for x in "$@"; do
-        y="${x// /_}"
-        safe_rename "$x" "$y"
+        y=$(tr "[A-Z]" "[a-z]" <<<"$x")
+        [[ $y != $x ]] && mv "$x" "$y"
     done
 }
 
 
 
 
-
-# test existence / exists
-te() {
-    local ret=0
+lower() { # make first letter of filenames lowercase.
+    local x
     for x in "$@"; do
-        [[ -e "$x" || -L "$x" ]] || ret=1
+        if [[ ${x::1} == [A-Z] ]]; then
+            y=$(tr "[A-Z]" "[a-z]" <<<"${x::1}")"${x:1}"
+            safe_rename "$x" "$y"
+        fi
     done
-    return $ret
-}
-
-# show make targets, via http://stackoverflow.com/questions/3063507/list-goals-targets-in-gnu-make
-make-targets() {
-    make -qp | awk -F':' '/^[a-zA-Z0-9][^$#\/\t=]*:([^=]|$)/ {split($1,A,/ /);for(i in A)print A[i]}'
 }
 
 
-# fix root file ownership for FILE argument.
-# check if parent or grandparent is not root and if the dir of FILE is also
-# owned by that user, and change ownership to that user
-perm_fix() {
-    local parent
-    if [[ $EUID == 0 ]]; then
-       te "$1" || touch "$1"
-       if [[ $(stat -c "%u" "$1") == 0 ]] ; then
-           argdir=$(getdir "$1")
-           if [[ $(stat -c "%u" "$argdir") != 0 ]] ; then
-               if ! chown "--reference=$argdir" "$1"; then
-                   echo failed to fix bad ownership file permissons
-                    return 1
-                fi
-           fi
-       fi
-    fi
+k() { # history search
+    grep -P --binary-files=text "$@" ${HISTFILE:-~/.bash_history}  | tail -n 40;
 }
 
-# see notes for usage
-fsdiff () {
-    local missing=false
-    local dname="${PWD##*/}"
-    local m="/a/tmp/$dname-missing"
-    local d="/a/tmp/$dname-diff"
-    [[ -e $d ]] && rm "$d"
-    [[ -e $m ]] && rm "$m"
-    local msize=0
-    local fsfile
-    while read -r line; do
-        fsfile="$1${line#.}"
-        if [[ -e "$fsfile" ]]; then
-            md5diff "$line" "$fsfile" && tee -a "/a/tmp/$dname-diff" <<< "$fsfile $line"
-        else
-            missing=true
-            echo "$line" >> "$m"
-            msize=$((msize + 1))
-        fi
-    done < <(find -type f )
-    if $missing; then
-        echo "$m"
-        (( msize <= 100 )) && cat $m
-    fi
-}
 
-fsdiff-test() {
-    cd $(mktemp -d)
-    echo ok > a
-    echo nok > b
-    mkdir c
-    echo ok > c/d
-    local x=$(mktemp -d)
-    mkdir $x/c
-    echo different > $x/c/d
-    echo ok > $x/a
-    fsdiff $x
+make-targets() {
+    # show make targets, via http://stackoverflow.com/questions/3063507/list-goals-targets-in-gnu-make
+    make -qp | awk -F':' '/^[a-zA-Z0-9][^$#\/\t=]*:([^=]|$)/ {split($1,A,/ /);for(i in A)print A[i]}'
 }
-# expected output, with different tmp dirs
-# /tmp/tmp.HDPbwMqdC9/c/d ./c/d
-# /a/tmp/tmp.qLDkYxBYPM-missing
-# ./b
 
 
-# test whether missing files were renamed, generally for use with fsdiff
-# $1 = fsdiff output file, $2 = directory to compare to. pwd = fsdiff dir
-# echos non-renamed files
-rename-test() {
-    local x y found
-    unset sums
-    for x in "$2"/*; do
-        { sums+=( "$(md5sum < "$x")" ) ; } 2>/dev/null
-    done
-    while read -r line; do
-        { missing_sum=$(md5sum < "$line") ; } 2>/dev/null
-        renamed=false
-        for x in "${sums[@]}"; do
-            if [[ $missing_sum == "$x" ]]; then
-                renamed=true
-                break
-            fi
-        done
-        $renamed || echo "$line"
-    done < "$1"
-    return 0
+mkc() {
+    mkdir "$1"
+    c "$1"
 }
 
+mkdir() { command mkdir -p "$@"; }
 
-# get a random string
-#par2rbase=$(head -c 50 /dev/urandom | tr -cd '[:alpha:]')
-par2r() {
-    [[ $par2rbase ]] || { echo "set \$par2rbase first"; return 1; }
-    d="$PWD"
-    for x in **; do
-        if [[ -d $x ]]; then
-            cd "$x"
-            par2 c QDLDeDJ6z4.par2 *
-            cd "$d"
-        fi
-    done
-
+pithos() {
+    cd /a/opt/Pithosfly/
+    python3 -m pithos&r
 }
 
-md5diff() {
-    [[ $(md5sum < "$1") != $(md5sum < "$2") ]]
+pakaraoke() {
+    # from http://askubuntu.com/questions/456021/remove-vocals-from-mp3-and-get-only-instrumentals
+    pactl load-module module-ladspa-sink sink_name=Karaoke master=alsa_output.usb-Audioengine_Audioengine_D1-00.analog-stereo plugin=karaoke_1409 label=karaoke control=-30
 }
 
 
@@ -683,34 +815,11 @@ pfind() { #find *$1* in $PATH
     find "${pathArray[@]}" -iname "*$1*"
 }
 
-# do pwd + some other info.
-#pwd() { echo "$(ll -d "$PWD")         $USER@$HOSTNAME         $(date +%r)"; }
-
-
-pwgen() { # generate a random password, with digits & punctuation and without
-    arg=${1:-50}
-    head -c 200 /dev/urandom | tr -cd '[:graph:]' | head -c "$arg"
-    echo
-    head -c 200 /dev/urandom | tr -cd '[:alnum:]' | head -c "$arg"
-    head -c 5 /dev/urandom | tr -cd '[:alpha:]' | head -c "$arg"
-    echo
-}
-
-q() { # start / launch a program in the backround and redir output to null
-    "$@" &> /dev/null &
-}
-
-
-
-r() {
-    exit "$@" 2>/dev/null
-}
-
-# trash-restore lists everything that has been trashed at or below CWD
-# This picks out files just in CWD, not subdirectories,
-# which also match grep $1, usually use $1 for a time string
-# which you get from running restore-trash once first
 pick-trash() {
+    # trash-restore lists everything that has been trashed at or below CWD
+    # This picks out files just in CWD, not subdirectories,
+    # which also match grep $1, usually use $1 for a time string
+    # which you get from running restore-trash once first
     local name x ask
     local nth=1
     # last condition is to not ask again for ones we skipped
@@ -729,55 +838,163 @@ pick-trash() {
     done
 }
 
-# rsync, root is required to keep permissions right.
-# rsync  --archive --human-readable --verbose --itemize-changes --checksum \(-ahvic\) \
-#                                      --no-times --delete
-# basically, make an exact copy, use checksums instead of file times to be more accurate
-rl() { rsync -ahvic --delete "$@"; }
-# don't delete files on the target end which do not exist on the original end:
-rld() { rsync -ahvic "$@"; }
-complete -F _rsync -o nospace rld rlt fl
-# rl without preserving modification time. for some reason I had this as default before.
-# perhaps that reason will come up again and I will document it.
-rlt() { rsync -ahvic --delete --no-t "$@"; }
+postconfin() {
+    local MAPFILE
+    mapfile -t
+    local s
+    [[ $EUID == 0 ]] || s=s
+    $s postconf -ev "${MAPFILE[@]}"
+}
+
+pub() {
+    rld /a/h/_site/ li:/var/www/iankelling.org/html
+}
+
+pubip() { curl -4s https://icanhazip.com; }
+whatismyip() { pubip; }
+
+
+pwgen() {
+    apg -m 12 -x 16 -t
+}
+
+
+q() { # start / launch a program in the backround and redir output to null
+    "$@" &> /dev/null &
+}
+
+r() {
+    exit "$@" 2>/dev/null
+}
+
+rbpipe() { rbt post -o --diff-filename=- "$@"; }
+rbp() { rbt post -o "$@"; }
+
+rl() {
+    # rsync, root is required to keep permissions right.
+    # rsync  --archive --human-readable --verbose --itemize-changes --checksum \(-ahvic\) \
+        #                                      --no-times --delete
+    # basically, make an exact copy, use checksums instead of file times to be more accurate
+    rsync -ahvic --delete "$@"
+}
+rld() {
+    # like rlu, but don't delete files on the target end which
+    # do not exist on the original end.
+    rsync -ahvic "$@"
+}
+complete -F _rsync -o nospace rld rl rlt
+
+rlt() {
+    # rl without preserving modification time.
+    rsync -ahvic --delete --no-t "$@"
+}
+
+rlu() { # [OPTS] HOST PATH
+    # eg rlu -opts frodo testpath
+    # useful for selectively sending dirs which have been synced with unison,
+    # where the path is the same on both hosts.
+    opts=("${@:1:$#-2}") #  1 to last -2
+    path="${@:$#}" # last
+    host="${@:$#-1:1}" # last -1
+    if [[ $path == .* ]]; then echo error: need absolut path; return 1; fi
+    # rync here uses checksum instead of time so we don't mess with
+    # unison relying on time as much. g is for group, same reason
+    # to keep up with unison.
+    s rsync -rlpchviog --relative "${opts[@]}" "$path" "root@$host:/";
+}
+
+
+rspicy() { # usage: HOST DOMAIN
+    # connect to spice vm remote host. use vspicy for local host
+    local port=$(ssh $1<<EOF
+sudo virsh dumpxml $2|grep "<graphics.*type='spice'" | \
+       sed -rn "s/.*port='([0-9]+).*/\1/p"
+EOF
+          )
+    if [[ $port ]]; then
+        spicy -h $1 -p $port
+    else
+        echo "error: no port found. check that the domain is running."
+    fi
+}
+
+s() {
+    # background
+    # I use a function because otherwise we can't use in a script,
+    # can't assign to variable.
+    #
+    # note: gksudo is recommended for X apps because it does not set the
+    # home directory to the same, and thus apps writing to ~ fuck things up
+    # with root owned files.
+    #
+    if [[ $EUID != 0 || $1 == -* ]]; then
+        SUDOD="$PWD" sudo -i "$@"
+    else
+        "$@"
+    fi
+}
 
+safe_rename() {
+    if [[ $# != 2 ]]; then
+        echo safe_rename error: $# args, need 2 >2
+        return 1
+    elif [[ $1 != $2 ]]; then
+        if [[ -e $2 ]]; then
+            echo Cannot rename "$1" to "$2" as it already exists.
+        else
+            mv "$1" "$2"
+        fi
+    fi
+}
 
 
-# use sb instead of s is for sudo redirections, eg. sb 'echo "ok fine" > /etc/file'
-sb() {
+sb() { # sudo bash -c
+    # use sb instead of s is for sudo redirections,
+    # eg. sb 'echo "ok fine" > /etc/file'
     local SUDOD="$PWD"
     sudo -i bash -c "$@"
 }
 complete -F _root_command s sb
 
-# use -ll, less secure but faster.
-srm () {
-    command srm -ll "$@"
-}
 
-# sudo redo. be aware, this command may not work right on strange distros or earlier software
-sr() {
-    if [[ $# == 0 ]]; then
-       sudo -E bash -c -l "$(history -p '!!')"
+ser() {
+    local s; [[ $EUID != 0 ]] && s=sudo
+    if type -p systemctl &>/dev/null; then
+        $s systemctl $1 $2
     else
-       echo this command redos last history item. no argument is accepted
+        $s service $2 $1
+    fi
+}
+
+sgo() { # service go
+    service=$1
+    ser restart $service
+    if type -p systemctl &>/dev/null; then
+        ser enable $service
     fi
 }
 
 
+shellck() {
+    # 2086 = unquoted $var
+    # 2046 = unquoted $(cmd)
+    # i had -x as an arg, but debian testing(stretch) doesn't support it
+    shellcheck -e 2086,2046,2068,2006,2119 "$@"
+}
+
 
-# log with script. timing is $1.t and script is $1.s
-# -l to save to ~/typescripts/
-# -t to add a timestamp to the filenames
 slog() {
+    # log with script. timing is $1.t and script is $1.s
+    # -l to save to ~/typescripts/
+    # -t to add a timestamp to the filenames
     local logdir do_stamp arg_base
     (( $# >= 1 )) || { echo "arguments wrong"; return 1; }
     logdir="/a/dt/"
     do_stamp=false
     while getopts "lt" option
     do
-       case $option in
-           l ) arg_base=$logdir ;;
+        case $option in
+            l ) arg_base=$logdir ;;
             t ) do_stamp=true ;;
         esac
     done
@@ -793,14 +1010,91 @@ splay() { # script replay
     scriptreplay "$1.t" "$1.s"
 }
 
+sr() {
+    # sudo redo. be aware, this command may not work right on strange distros or earlier software
+    if [[ $# == 0 ]]; then
+        sudo -E bash -c -l "$(history -p '!!')"
+    else
+        echo this command redos last history item. no argument is accepted
+    fi
+}
+
+srm () {
+    # with -ll, less secure but faster.
+    command srm -ll "$@"
+}
+
+srun() {
+    scp $2 $1:/tmp
+    ssh $1 /tmp/${2##*/} "${@:2}"
+}
+
+t() {
+    local x
+    local -a args
+    if type -t trash-put >/dev/null; then
+        # skip args that don't exist, or else trash-put will have an error
+        for x in "$@"; do
+            if [[ -e $x || -L $x ]]; then
+                args+=("$x")
+            fi
+        done
+        [[ ! ${args[@]} ]] || trash-put "${args[@]}"
+    else
+        rm -rf "$@"
+    fi
+}
+
+
+tclock() {
+    clear
+    date +%l:%_M
+    len=60
+    # this goes to full width
+    #len=${1:-$((COLUMNS -7))}
+    x=1
+    while true; do
+        if (( x == len )); then
+            end=true
+            d="$(date +%l:%_M)   "
+        else
+            end=false
+            d=$(date +%l:%M:%_S)
+        fi
+        echo -en "\r"
+        echo -n "$d"
+        for ((i=0; i<x; i++)); do
+            if (( i % 6 )); then
+                echo -n _
+            else
+                echo -n .
+            fi
+        done
+        if $end; then
+            echo
+            x=1
+        else
+            x=$((x+1))
+        fi
+        sleep 5
+    done
+}
 
 
-# timer in minutes
+te() {
+    # test existence / exists
+    local ret=0
+    for x in "$@"; do
+        [[ -e "$x" || -L "$x" ]] || ret=1
+    done
+    return $ret
+}
+
 tm() {
+    # timer in minutes
     (sleep $(calc "$@ * 60") && mpv --volume 50 /a/bin/data/alarm.mp3) > /dev/null 2>&1 &
 }
 
-
 ts() { # start editing a new file
     [[ $# != 1 ]] && echo "I need a filename." && return 1
     local quiet
@@ -808,101 +1102,156 @@ ts() { # start editing a new file
         quiet=true
     fi
     if [[ $1 == *.c ]]; then
-       e '#include <stdio.h>' >"$1"
-       e '#include <stdlib.h>' >>"$1"
-       e 'int main(int argc, char * argv[]) {' >>"$1"
-       e '     printf( "hello world\n");' >>"$1"
-       e '     return 0;' >>"$1"
-       e '}' >>"$1"
-       e "${1%.c}: $1" > Makefile
-       e "     g++ -ggdb -std=gnu99 -o ${1%.c} $<" >> Makefile
-       e "#!/bin/bash" >run.sh
-       e "./${1%.c}" >>run.sh
-       chmod +x run.sh
+        e '#include <stdio.h>' >"$1"
+        e '#include <stdlib.h>' >>"$1"
+        e 'int main(int argc, char * argv[]) {' >>"$1"
+        e '    printf( "hello world\n");' >>"$1"
+        e '    return 0;' >>"$1"
+        e '}' >>"$1"
+        e "${1%.c}: $1" > Makefile
+        e "    g++ -ggdb -std=gnu99 -o ${1%.c} $<" >> Makefile
+        e "#!/bin/bash" >run.sh
+        e "./${1%.c}" >>run.sh
+        chmod +x run.sh
     elif [[ $1 == *.java ]]; then
-       e "public class ${1%.*} {" >"$1"
-       e '     public static void main(String[] args) {' >>"$1"
-       e '             System.out.println("Hello, world!");' >>"$1"
-       e '     }' >>"$1"
-       e '}' >>"$1"
-
+        e "public class ${1%.*} {" >"$1"
+        e '    public static void main(String[] args) {' >>"$1"
+        e '            System.out.println("Hello, world!");' >>"$1"
+        e '    }' >>"$1"
+        e '}' >>"$1"
     else
-       echo "#!/bin/bash" > "$1"
-       chmod +x "$1"
+        echo "#!/bin/bash" > "$1"
+        chmod +x "$1"
     fi
     [[ $quiet ]] || g "$1"
+}
+
 
+tu() {
+    local s;
+    local dir="$(dirname "$1")"
+    if [[ -e $1 && ! -w $1 || ! -w $(dirname "$1") ]]; then
+        s=s;
+    fi
+    $s teeu "$@"
 }
 
 tx() { # toggle set -x, and the prompt so it doesn't spam
     if [[ $- == *x* ]]; then
-       set +x
+        set +x
         PROMPT_COMMAND=prompt_command
     else
         unset PROMPT_COMMAND
         PS1="\w \$ "
-       set -x
+        set -x
     fi
 }
 
+vc() {
+    [[ $1 ]] || { e "$0: error, expected cmd to run"; return 1; }
+    # manually run vpn so it stays within a network namespace,
+    # until I get it all wired up with systemd.
+    newns vpn start
+    pid=$(< /run/openvpn/client.pid)
+    vpn_on=false
+    if [[ $pid ]]; then
+        if [[ -e /proc/$pid ]]; then
+            vpn_on=true
+        else
+            vpn_on=false
+            s rm -f /run/openvpn/client.pid
+        fi
+    fi
+    $vpn_on || s ip netns exec vpn /usr/sbin/openvpn --daemon ovpn --config /etc/openvpn/client.conf --cd /etc/openvpn --writepid /run/openvpn/client.pid
+    gksudo -- ip netns exec vpn gksudo -u ${SUDO_USER:-$USER} "$@"
+}
 
+transmission() {
+    vc transmission-gtk&
+    i=0
+    while true; do
+        if ((i > 10)); then
+            echo "$0: error: vpn tun0 didn't show up"
+            return 1
+        fi
+        tun_ip=$(s ip netns exec vpn ip a show dev tun0 | sed -rn 's/^ *inet (10\.8\.\S+).*/\1/p')
+        [[ ! $tun_ip ]] || break
+        sleep 1
+        i=$((i + 1))
+    done
+    echo "$0: tun_ip=$tun_ip"
+    [[ $tun_ip ]] || { e "$0: error: no tun0 addr found"; return 1; }
+    ssh dopub bash <<EOF
+set -e
+rule="-A PREROUTING -i eth0 -p tcp -m tcp --dport 63324 -j DNAT --to-destination $tun_ip:63324"
+found=false
+while read -r line; do
+  if [[ \$line == \$rule ]] && ! \$found; then
+    found=true
+  else
+    iptables -t nat -D \${line#-A}
+  fi
+done < <(iptables -t nat -S | grep -E -- '--dport\s+63324')
+\$found || iptables -t nat \$rule
+EOF
+}
 
+virshrm() {
+    for x in "$@"; do virsh destroy "$x"; virsh undefine "$x"; done
+}
 
-if [[ $OS == Windows_NT ]]; then
-    # cygstart wrapper
-    cs() {
-       cygstart "$@" &
-    }
-    xp() {
-       explorer.exe .
-    }
-    # launch
-    o() {
-       local x=(*$1*)
-       (( ${#x[#]} > 1 )) && { echo "warning ${#x[#]} matches found"; sleep 1; }
-       cygstart *$1* &
-    }
-else
-    o() {
-       if type gvfs-open &> /dev/null ; then
-           gvfs-open "$@"
-       else
-           xdg-open "$@"
-       fi
-        # another alternative is run-mailcap
-    }
-fi
+vm-set-listen(){
+    local t=$(mktemp)
+    local vm=$1
+    local ip=$2
+    s virsh dumpxml $vm | sed -r "s/(<listen.*address=')([^']+)/\1$ip/" | \
+        sed -r "s/listen='[^']+/listen='$ip/"> $t
+    s virsh undefine $vm
+    s virsh define $t
+}
 
 
+vmshare() {
+    vm-set-listen $1 0.0.0.0
+}
 
 
-# todo, update this
-complete -F _longopt la lower low rlt rld rl lld ts ll dircp ex fcp fct fpst gr
+vmunshare() {
+    vm-set-listen $1 127.0.0.1
+}
 
+vpn() {
+    s systemctl start openvpn@client&
+    journalctl --unit=openvpn@client -f -n0
+}
 
 
-hl() { # history limit. Write extra history to archive file.
-    local max_lines linecount tempfile prune_lines
-    local harchive="${HISTFILE}_archive"
-    for x in "$HISTFILE" "$harchive"; do
-        [[ -e $x ]] || { touch "$x" && echo "notice from hl(): creating $x"; }
-        if  [[ ! $x || ! -e $x || ! -w $x || $(stat -c "%u" "$x") != $EUID  ]];  then
-            echo "error in hl: history file \$x:$x no good"
-           return 1
-        fi
-    done
-    history -a # save history
-    max_lines=$HISTFILELINES
-    [[ $max_lines =~ ^[0-9]+$ ]] || { echo "error in hl: failed to get max line count"; return 1; }
-    linecount=$(wc -l < $HISTFILE) # pipe so it doesn't output a filename
-    [[ $linecount =~ ^[0-9]+$ ]] || { echo "error in hl: wc failed"; return 1; }
-    if (($linecount > $max_lines)); then
-       prune_lines=$(($linecount - $max_lines))
-       head -n $prune_lines "$HISTFILE" >> "$harchive" \
-           && sed -ie "1,${prune_lines}d"  $HISTFILE
-    fi
+vpnoff() {
+    s systemctl stop openvpn@client
+}
+
+
+vrm() {
+    virsh destroy $1
+    virsh undefine $1
 }
 
+
+
+vspicy() { # usage: VIRSH_DOMAIN
+    # connect to vms made with virt-install
+    spicy -p $(sudo virsh dumpxml "$1"|grep "<graphics.*type='spice'"|\
+                   sed -r "s/.*port='([0-9]+).*/\1/")
+}
+
+
+whatismyip() { curl ipecho.net/plain ; echo; }
+
+
+#############################
+######### misc stuff ########
+#############################
+
 if [[ $- == *i* ]]; then
     # commands to run when bash exits normally
     trap "hl; _smh" EXIT
@@ -985,7 +1334,7 @@ if [[ $- == *i* ]]; then
     if [[ $OS != Windows_NT ]]; then
         GIT_PS1_SHOWDIRTYSTATE=true
     fi
-    # arch source location
+    # arch source lopip show -fcation
     [[ -r /usr/share/git/git-prompt.sh ]] && source /usr/share/git/git-prompt.sh
     # fedora/debian source
     [[ -r /usr/share/git-core/contrib/completion/git-prompt.sh ]] && source /usr/share/git-core/contrib/completion/git-prompt.sh
@@ -1019,7 +1368,6 @@ if [[ $- == *i* ]]; then
         local ps_char ps_color
         unset IFS
         history -a # save history
-        history -n # read any new history
         if [[ ! $DESKTOP_SESSION == xmonad && $TERM == *(screen*|xterm*|rxvt*) ]]; then
             # from the screen man page
             if [[ $TERM == screen* ]]; then
@@ -1048,7 +1396,9 @@ if [[ $- == *i* ]]; then
                ps_color="$(get_term_color bold green)"
             fi
         fi
-        PS1="${PS1%"${PS1#*[wW]}"}$(__git_ps1 ' (%s)') \[$ps_color\]$ps_char\[$(get_term_color nocolor)\] "
+        PS1="${PS1%"${PS1#*[wW]}"} \[$ps_color\]$ps_char\[$(get_term_color nocolor)\] "
+        # emacs completion doesn't like the git prompt atm, so disabling it.
+        #PS1="${PS1%"${PS1#*[wW]}"}$(__git_ps1 ' (%s)') \[$ps_color\]$ps_char\[$(get_term_color nocolor)\] "
     }
     PROMPT_COMMAND=prompt_command
 fi
@@ -1062,6 +1412,7 @@ fi
 ###########################################
 if [[ "$SUDOD" ]]; then
     cd "$SUDOD"
+    unset SUDOD
 elif [[ -d /a ]] && [[ $PWD == $HOME ]] && [[ $- == *i* ]]; then
     cd /a
 fi
@@ -1075,3 +1426,43 @@ unset IFS
 if [[ $SOE ]]; then
     errcatch
 fi
+
+# I'd prefer to have system-wide, plus user ruby, due to bug in it
+# https://github.com/rubygems/rubygems/pull/1002
+# further problems: installing multi-user ruby and user ruby,
+# you don't get multi-user ruby when you sudo to root, unless its sudo -i.
+# There a third hybrid form, which passenger error suggested I use,
+# but it didn't actually work.
+
+# in cased I never need this
+# rvm for non-interactive shell: modified from https://rvm.io/rvm/basics
+#if [[ $(type -t rvm) == file && ! $(type -t ruby) ]]; then
+#    source $(rvm 1.9.3 do rvm env --path)
+#fi
+
+# based on warning from rvmsudo
+export rvmsudo_secure_path=1
+
+# for other script I wrote
+#export ACME_TINY_PATH=/a/opt/acme-tiny
+export ACME_TINY_WRAPPER_CERT_DIR=/p/c/machine_specific/$HOSTNAME/webservercerts
+
+if [[ -s "/usr/local/rvm/scripts/rvm" ]]; then
+    source "/usr/local/rvm/scripts/rvm"
+elif [[ -s $HOME/.rvm/scripts/rvm ]]; then
+    source $HOME/.rvm/scripts/rvm
+fi
+
+
+path_add --end ~/.npm-global
+
+# https://wiki.archlinux.org/index.php/Xinitrc#Autostart_X_at_login
+# i added an extra condition as gentoo xorg guide says depending on
+# $DISPLAY is fragile.
+if [[ ! $DISPLAY && $XDG_VTNR == 1 ]] && shopt -q login_shell && isarch; then
+    exec startx
+fi
+
+
+# ensure no bad programs appending to this file will have an affect
+return 0